-- name: [CS] Bendy The Ink Demon
-- description: the little demon is returning to the world of Mario after 1 year!

if not _G.charSelectExists then
    djui_popup_create("\\#ffffa0\\Bendy requires\nCharacter Select to be enabled.\n\nPlease rehost with it enabled.", 4)
    return
end

-- Characters are stored in a table for ease of addition

Bendy = {
    --------------
    -- Bendy --
    --------------
    {
        name = "Bendy",
        description = "The most famous little ink demon of the 30s! They say a trouser mouse is his copy, do you think?",
        credits = "Joey Drew Studios, VectorLua",
        color = { r = 225, g = 0, b = 0 },
        model = smlua_model_util_get_id("bendy_geo"),
        forceChar = CT_MARIO,
        lifeIcon = get_texture_info("bendy-icon"),
        camScale = 0.8,
        offset = 0,
        palette = {
            [PANTS]  = { r = 0, g = 0, b = 0 },
            [SHIRT]  = { r = 0, g = 0, b = 0 },
            [GLOVES] = { r = 225, g = 225, b = 225 },
            [SHOES]  = { r = 0, g = 0, b = 0 },
            [HAIR]   = { r = 0, g = 0, b = 0 },
            [SKIN]   = { r = 0, g = 0, b = 0 },
            [CAP]    = { r = 0, g = 0, b = 0 },
            [EMBLEM] = { r = 0, g = 0, b = 0 }
        },
        voices = {
            [CHAR_SOUND_ATTACKED] = "attacked.ogg",
            [CHAR_SOUND_COUGHING1] = "yah.ogg",
            [CHAR_SOUND_COUGHING2] = "wah.ogg",
            [CHAR_SOUND_COUGHING3] = "hoo.ogg",
            [CHAR_SOUND_DOH] = "doh.ogg",
            [CHAR_SOUND_DROWNING] = "attacked.ogg",
            [CHAR_SOUND_DYING] = "attacked.ogg",
            [CHAR_SOUND_EEUH] = "uh2.ogg",
            [CHAR_SOUND_GROUND_POUND_WAH] = "uh.ogg",
            [CHAR_SOUND_HAHA] = "uh2.ogg",
            [CHAR_SOUND_HAHA_2] = "uh2.ogg",
            [CHAR_SOUND_HERE_WE_GO] = "herewego.ogg",
            [CHAR_SOUND_HOOHOO] = "hoo.ogg",
            [CHAR_SOUND_HRMM] = "uh.ogg",
            [CHAR_SOUND_IMA_TIRED] = "uh2.ogg",
            [CHAR_SOUND_MAMA_MIA] = "attacked.ogg",
            [CHAR_SOUND_LETS_A_GO] = "herewego.ogg",
            [CHAR_SOUND_OOOF] = "uh.ogg",
            [CHAR_SOUND_OOOF2] = "uh2.ogg",
            [CHAR_SOUND_PUNCH_HOO] = "hoo.ogg",
            [CHAR_SOUND_PUNCH_WAH] = "wah.ogg",
            [CHAR_SOUND_PUNCH_YAH] = "yah.ogg",
            [CHAR_SOUND_SO_LONGA_BOWSER] = "solongbowser.ogg",
            [CHAR_SOUND_TWIRL_BOUNCE] = "solongbowser.ogg",
            [CHAR_SOUND_UH] = "uh.ogg",
            [CHAR_SOUND_UH2] = "uh2.ogg",
            [CHAR_SOUND_UH2_2] = "uh.ogg",
            [CHAR_SOUND_WAAAOOOW] = "attacked.ogg",
            [CHAR_SOUND_WAH2] = "wah.ogg",
            [CHAR_SOUND_WHOA] = "uh.ogg",
            [CHAR_SOUND_YAHOO] = "hoo.ogg",
            [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = { "yah.ogg", "hoo.ogg", "wah.ogg"},
            [CHAR_SOUND_YAH_WAH_HOO] = { "yah.ogg", "wah.ogg", "hoo.ogg"},
        },  
        anims = nil
    },
}

local CSloaded = false
local function on_character_select_load()
    for i = 1, #Bendy do
        local char = Bendy[i]
        char.tablePos = _G.charSelect.character_add(char.name, char.description, char.credits, char.color, char.model, char.forceChar, char.lifeIcon, char.camScale, char.offset)
        if char.caps then _G.charSelect.character_add_caps(char.model, char.caps) end
        if char.voices then _G.charSelect.character_add_voice(char.model, char.voices) end
        if char.palette then _G.charSelect.character_add_palette_preset(char.model, char.palette) end
        if char.anims then _G.charSelect.character_add_animations(char.model, char.anims) end
    end

    CSloaded = true
end

local function on_character_sound(m, sound)
    if not CSloaded then return end
    for i = 1, #Bendy do
        if _G.charSelect.character_get_voice(m) == Bendy[i].voices then return _G.charSelect.voice.sound(m, sound) end
    end
end

local function on_character_snore(m)
    if not CSloaded then return end
    for i = 1, #Bendy do
        if _G.charSelect.character_get_voice(m) == Bendy[i].voices then return _G.charSelect.voice.snore(m) end
    end
end

hook_event(HOOK_ON_MODS_LOADED, on_character_select_load)
hook_event(HOOK_CHARACTER_SOUND, on_character_sound)
hook_event(HOOK_MARIO_UPDATE, on_character_snore)